program Sparse_MxV_mult
use sep
use dottest 
use sparse_matmult1 

implicit none
real, dimension (:),     allocatable :: x,y
real, dimension (:,:),       pointer :: H
real, dimension (2)                  :: dot1,dot2
integer                              :: stat,n1,n2
logical                              :: adj,add

call sep_init( )

call from_history('n1',n1)
call from_history('n2',n2)

allocate(H(n1,n2),x(50),y(50))
call sep_read(H)
x=0
x(25)=1.
y=0 

call smatmult_init (H)
call dot_test(smatmult_lop,50,50,dot1,dot2)

adj=.false.
add=.false.
stat = smatmult_lop(adj, add, x, y)

call sep_write(y)

call to_history('n1',10)
call to_history('n2',5)

deallocate(x,y,H)
end program Sparse_MxV_mult
