program stack3d 
use sep

implicit none

integer                          :: n1,n2,n3
real                             :: o1,o2,o3
real                             :: d1,d2,d3 
integer                          :: esize,i1,i2,i3
real, dimension(:,:), allocatable           :: data
real, dimension(:,:), allocatable             :: model
integer, external                :: sreed,srite

call sep_init(SOURCE)

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history("esize",esize)

call to_history('n1',n1); call to_history('d1',d1); call to_history('o1',o1) 
call to_history('n2',n2); call to_history('d2',d2); call to_history('o2',o2) 
call to_history('n3',1 ); call to_history('d3',1 ); call to_history('o3',1 ) 

write(0,*)"n1,n2,n3,n4",n1,n2,n3
write(0,*)"d1,d2,d3,d4",d1,d2,d3
write(0,*)"o1,o2,o3,o4",o1,o2,o3

allocate(data(n1,n2),model(n1,n2))
model=0.

do i3=1, n3
  write(0,*)"i3",i3
  if (sreed("in",data,esize*n1*n2) /= esize*n1*n2) &
  call seperr("Error reading data")
  do i2=1,n2
  do i1=1,n1
      model(i1,i2)=model(i1,i2)+data(i1,i2)
  enddo
  enddo
enddo

if (srite("out",model,esize*n1*n2) /= esize*n1*n2) &
call seperr("Error writing model")

deallocate(data,model)

end program stack3d 
