! Expects data to be (n1*n1*n4) the ns come from the green function
program mig
use sep

implicit none
integer                          :: n1,n2,n3,n4
real                             :: o1,o2,o3,o4
real                             :: d1,d2,d3,d4 
integer                          :: esize,ix,ixr,ixs,i,iz,block_size
complex, dimension(:,:,:)        :: data
real, dimension(:,:,:)           :: modelw
complex, dimension(:,:,:,:)      :: green
integer, external                :: sreed,srite


call sep_init(SOURCE)

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call to_history('n1',n2); call to_history('d1',d2); call to_history('o1',o2) ; call to_history('label1',"z_")
call to_history('n2',n3); call to_history('d2',d3); call to_history('o2',o3) ; call to_history('label2',"x_")
call to_history('n3',n4); call to_history('d3',d4); call to_history('o3',o4) ; call to_history('label3',"w_")
call to_history('n4', 1); call to_history('d4',0.); call to_history('o4',0.) ; call to_history('label4',"  ")
call to_history("esize",esize/2)

write(0,*)"n1,n2,n3,n4",n1,n2,n3,n4
write(0,*)"d1,d2,d3,d4",d1,d2,d3,d4
write(0,*)"o1,o2,o3,o4",o1,o2,o3,o4

allocate(green(n1,n2,n3,n4),data(n1,n1,n4),modelw(n2,n3,n4))

if (sreed("in",green,esize*n1*n2*n3*n4) /= esize*n1*n2*n3*n4) &
call seperr("Error reading Green function")

modelw=0.
if (sreed("data",data,esize*n1*n1*n4) /= esize*n1*n1*n4) &
call seperr("Error reading data")

do ix=1,n3
  do iz=1,n2
    do ixs=1,n1
    do ixr=1,n1
      modelw(iz,ix,:)=modelw(iz,ix,:)+conjg(green(ixs,iz,ix,:))*conjg(green(ixr,iz,ix,:))*conjg(data(ixr,ixs,:))
    enddo
    enddo
  enddo
enddo

if (srite("out",modelw,esize*n2*n3*n4/2) /= esize*n2*n3*n4/2) &
call seperr("Error writing image")

deallocate(green,data,modelw)

end program mig 
