      module omp_sector  !  omp part of L_tL programs
      
      contains

      subroutine omp_do(nx_in,nsx_in,nz_in,noff_in,nxh_in,nzh_in,nzh2_in,nxh2_in,ix_in,ioff_in,green_in,LtL_out)
      implicit none
      integer                      , intent (in)  :: nx_in,nsx_in,nz_in,noff_in,nxh_in,nzh_in,nzh2_in,nxh2_in,ix_in,ioff_in
      complex, dimension(:,:,:)    , intent (in)  :: green_in
      complex, dimension(:,:,:,:,:), intent (out) :: LtL_out
      complex, dimension(:)        , allocatable  :: aaaixz,aaajxz
      integer                                     :: iz,ihz,ihx,is,ir,isr,i1,ioff1,iix,iiz,jjx
      complex                                     :: ppp,pp

      allocate(aaaixz(nsx_in),aaajxz(nsx_in))
      jjx=ix_in+ioff_in-1
      do iz=1,nz_in
        if ( (jjx >= 1) .and. (jjx <= nx_in) ) then
          aaaixz(1:nsx_in)=conjg(green_in(1:nsx_in,iz,jjx))
        else
          aaaixz(1:nsx_in)=(0.,0.)
        endif
        do ioff1=1,noff_in
        do ihx=1,nxh_in
        iix=ix_in-nxh2_in+ihx-1-ioff1+1
        do ihz=1,nzh_in
          iiz=iz-nzh2_in+ihz-1
          if (  (iiz >= 1 ) .and. (iix >=1  )    .and. &
                (iiz <= nz_in) .and. (iix <= nx_in)  ) then
            aaajxz(1:nsx_in)=green_in(1:nsx_in,iiz,iix)
          else
            aaajxz(1:nsx_in)=(0.,0.   )
          endif
          ppp=(0.,0.)
          do is=1,nsx_in
            pp=aaaixz(is)*aaajxz(is)
            do ir=1,nsx_in,2 ! ojo esto hay que hacerlo mejor
              ppp=ppp+pp*aaaixz(ir)*aaajxz(ir)
            enddo
          enddo
          LtL_out(ihz,ihx,ioff1,iz,ix_in)=ppp
        enddo
        enddo
        enddo
      enddo
      deallocate(aaaixz,aaajxz)
      end subroutine

      end module
