! shot-profile migration
! uses split-step fourier downward continuation  with N reference velocities.
! written by Brad Artman, 2/2003

program Shotprofile
  use wei_SPmig
  use wei_wem
  use wei_SPig
  use wei_ssf
  use wei_sll
  use sep

  logical::verb
  integer::stat,ierr,iverb,n,i



  !----------------------------------------------------------------
  
  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")

  call set_no_putch()

  !----------------------------------------------------------------

  call SPmig_init(SLin=sll_init,&
                  WCin=kxmigN_init,&
                  FKin=wem_init,&
                  FXin=ssf_init,&
                  IGin=SPig_init )
  write(0,*)'Calling SPmig '
  stat=SPmig(.true.,down%add,down%R,down%D,down%D_d, &
             SLop=sll, &
             WCop=kxmigN_DSR, &
             FKop=wem,&
             FXop=ssf,&
             IGop=SPigop)
!             IGop_m=SPigop_m)

  write(0,*)' ' 
  write(0,*)'Gracias a Dios (y el Brad):  TERMINE !'

  call sep_end_prog()
  call exit(0)

end program Shotprofile
