program stack6d 
use sep

implicit none

integer                          :: n1,n2,n3,n4,n5,n6
real                             :: o1,o2,o3,o4,o5,o6
real                             :: d1,d2,d3,d4,d5,d6 
integer                          :: esize,i1,i2,i3,i4,i5,i6
real, dimension(:,:,:,:,:) ,allocatable        :: data, model
integer, external                :: sreed,srite


call sep_init(SOURCE)

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history('n5',n5); call from_history('d5',d5); call from_history('o5',o5)
call from_history('n6',n6); call from_history('d6',d6); call from_history('o6',o6)
call from_history("esize",esize)

call to_history('n1',n1); call to_history('d1',d1); call to_history('o1',o1) 
call to_history('n2',n2); call to_history('d2',d2); call to_history('o2',o2) 
call to_history('n3',n3); call to_history('d3',d3); call to_history('o3',o3) 
call to_history('n4',n4); call to_history('d4',d4); call to_history('o4',o4) 
call to_history('n5',n5 ); call to_history('d5',d5 ); call to_history('o5',o5 ) 
call to_history('n6',1 ); call to_history('d5',1 ); call to_history('o5',1 ) 

write(0,*)"n1,n2,n3,n4",n1,n2,n3,n4,n5,n6
write(0,*)"d1,d2,d3,d4",d1,d2,d3,d4,d5,d6
write(0,*)"o1,o2,o3,o4",o1,o2,o3,o4,o5,o6

allocate(data(n1,n2,n3,n4,n5),model(n1,n2,n3,n4,n5))
model=0.

  do i6=1,n6
  write(0,*)"i6",i6
  if (sreed("in",data,esize*n1*n2*n3*n4*n5) /= esize*n1*n2*n3*n4*n5) &
  call seperr("Error reading data")
  do i5=1,n5
  do i4=1,n4
  do i3=1,n3
  do i2=1,n2
  do i1=1,n1
      model(i1,i2,i3,i4,i5)=model(i1,i2,i3,i4,i5)+data(i1,i2,i3,i4,i5)
  enddo
  enddo
  enddo
  enddo
  enddo
  enddo

if (srite("out",model,esize*n1*n2*n3*n4*n5) /= esize*n1*n2*n3*n4*n5) &
call seperr("Error writing model")

deallocate(data,model)

end program stack6d 
